import { map } from 'rxjs/operators';
import { BehaviorSubject, of } from 'rxjs';
import { __spread } from 'tslib';
import { isPlatformBrowser, CommonModule } from '@angular/common';
import { Inject, Injectable, Optional, PLATFORM_ID, ChangeDetectionStrategy, Component, Input, ViewEncapsulation, HostListener, Host, HostBinding, NgModule, defineInjectable, inject } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var hasV8BreakIterator = (typeof Intl !== 'undefined' && ((/** @type {?} */ (Intl))).v8BreakIterator);
var Platform = /** @class */ (function () {
    function Platform(_platformId) {
        this._platformId = _platformId;
    }
    Object.defineProperty(Platform.prototype, "isBrowser", {
        // Browser check.
        get: 
        // Browser check.
        /**
         * @return {?}
         */
        function () {
            return this._platformId
                ? isPlatformBrowser(this._platformId)
                : typeof document === 'object' && !!document;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Platform.prototype, "isTrident", {
        // Rendering engines.
        get: 
        // Rendering engines.
        /**
         * @return {?}
         */
        function () {
            return this.isBrowser && /(msie|trident)/i.test(navigator.userAgent);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Platform.prototype, "isBlink", {
        get: /**
         * @return {?}
         */
        function () {
            return this.isBrowser && (!!(((/** @type {?} */ (window))).chrome || hasV8BreakIterator) &&
                typeof CSS !== 'undefined' && !this.isEdge && !this.isTrident);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Platform.prototype, "isWebkit", {
        get: /**
         * @return {?}
         */
        function () {
            return this.isBrowser && /AppleWebKit/i.test(navigator.userAgent)
                && !this.isBlink && !this.isEdge && !this.isTrident;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Platform.prototype, "isChrome", {
        // Browsers.
        get: 
        // Browsers.
        /**
         * @return {?}
         */
        function () {
            return this.isBrowser && /Google Inc./.test(navigator.vendor);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Platform.prototype, "isEdge", {
        get: /**
         * @return {?}
         */
        function () {
            return this.isBrowser && /(edge)/i.test(navigator.userAgent);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Platform.prototype, "isFirefox", {
        get: /**
         * @return {?}
         */
        function () {
            return this.isBrowser && /(firefox|minefield)/i.test(navigator.userAgent);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Platform.prototype, "isSafari", {
        get: /**
         * @return {?}
         */
        function () {
            return this.isBrowser && /safari/i.test(navigator.userAgent) && this.isWebkit;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Platform.prototype, "isIos", {
        // Platforms.
        get: 
        // Platforms.
        /**
         * @return {?}
         */
        function () {
            return this.isBrowser && /iPad|iPhone|iPod/.test(navigator.userAgent) && !('MSStream' in window);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Platform.prototype, "isAndroid", {
        get: /**
         * @return {?}
         */
        function () {
            return this.isBrowser && /android/i.test(navigator.userAgent) && !this.isTrident;
        },
        enumerable: true,
        configurable: true
    });
    Platform.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    Platform.ctorParameters = function () { return [
        { type: Object, decorators: [{ type: Optional }, { type: Inject, args: [PLATFORM_ID,] }] }
    ]; };
    /** @nocollapse */ Platform.ngInjectableDef = defineInjectable({ factory: function Platform_Factory() { return new Platform(inject(PLATFORM_ID, 8)); }, token: Platform, providedIn: "root" });
    return Platform;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BbDashboard = /** @class */ (function () {
    function BbDashboard() {
        // Inputs.
        this.backgroundColor = '#d5dae6';
        this.maxWidth = '1200px';
        this.padding = '20px';
        // State.
        this.sidebarVisible$ = new BehaviorSubject(true);
    }
    Object.defineProperty(BbDashboard.prototype, "visibility", {
        get: /**
         * @return {?}
         */
        function () {
            return this.sidebarVisible$.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    BbDashboard.prototype.toggleSidebarVisibility = /**
     * @return {?}
     */
    function () {
        // Get the previous value.
        /** @type {?} */
        var previousValue = this.sidebarVisible$.getValue();
        // Invert the value and set the visibility.
        this.setSidebarVisibility(!previousValue);
    };
    /**
     * @param {?} newValue
     * @return {?}
     */
    BbDashboard.prototype.setSidebarVisibility = /**
     * @param {?} newValue
     * @return {?}
     */
    function (newValue) {
        this.sidebarVisible$.next(newValue);
    };
    BbDashboard.decorators = [
        { type: Component, args: [{
                    selector: 'bb-dashboard',
                    template: "<!--\r\n    The outlet for where the sidebar\r\n    will be placed (if provided).\r\n-->\r\n<ng-content select=\"bb-dashboard-sidebar\">\r\n</ng-content>\r\n\r\n<!--\r\n    The section containing the header\r\n    and the main content.\r\n-->\r\n<section class=\"bb-dashboard-section\">\r\n    <!--\r\n        The outlet for where the header\r\n        will be placed (if provided).\r\n    -->\r\n    <ng-content select=\"bb-dashboard-header\">\r\n    </ng-content>\r\n\r\n    <!--\r\n        The outlet of the content that\r\n        will be provided by the router.\r\n    -->\r\n    <main [style.background-color]=\"backgroundColor\"\r\n          [style.padding]=\"padding\"\r\n          class=\"bb-dashboard-scroll\">\r\n        <div [style.max-width]=\"maxWidth\"\r\n             class=\"bb-dashboard-container\">\r\n            <ng-content></ng-content>\r\n        </div>\r\n    </main>\r\n</section>\r\n\r\n<!--\r\n    The backdrop that will be visible when\r\n    the sidebar is opened (only on mobile).\r\n-->\r\n<div [class.bb-dashboard-backdrop--visible]=\"!(visibility | async)\"\r\n     (click)=\"toggleSidebarVisibility()\"\r\n     class=\"bb-dashboard-backdrop\">\r\n</div>",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None,
                    preserveWhitespaces: false,
                    host: {
                        'class': 'bb-dashboard'
                    },
                    styles: [".bb-dashboard{height:100vh;display:-ms-flexbox;display:flex;overflow:hidden}.bb-dashboard-section{-ms-flex:1;flex:1;height:100vh;display:-ms-flexbox;display:flex;overflow-x:hidden;-ms-flex-direction:column;flex-direction:column}.bb-dashboard-scroll{-ms-flex:1;flex:1;overflow-x:hidden;overflow-y:scroll;-webkit-overflow-scrolling:touch}.bb-dashboard-container{width:100%;margin:0 auto}.bb-dashboard-backdrop{top:0;left:0;right:0;bottom:0;opacity:0;z-index:5;position:absolute;will-change:opacity;pointer-events:none;background-color:rgba(0,0,0,.5);transition:opacity .2s cubic-bezier(0,0,.2,1)}.bb-dashboard-backdrop--visible{opacity:1;cursor:pointer;pointer-events:all}@media only screen and (min-width:768px){.bb-dashboard-backdrop{display:none}}"]
                }] }
    ];
    BbDashboard.propDecorators = {
        backgroundColor: [{ type: Input }],
        maxWidth: [{ type: Input }],
        padding: [{ type: Input }]
    };
    return BbDashboard;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BbDashboardHeader = /** @class */ (function () {
    function BbDashboardHeader(_parent) {
        this._parent = _parent;
    }
    Object.defineProperty(BbDashboardHeader.prototype, "isSidebarVisible", {
        get: /**
         * @return {?}
         */
        function () {
            return this._parent
                ? this._parent.visibility
                : of(false);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    BbDashboardHeader.prototype.onToggleSidebarClicked = /**
     * @return {?}
     */
    function () {
        // If the parent exists toggle the sidebar visibility.
        if (!this._parent) {
            return;
        }
        this._parent.toggleSidebarVisibility();
    };
    BbDashboardHeader.decorators = [
        { type: Component, args: [{
                    selector: 'bb-dashboard-header',
                    template: "<!--\r\n    The button that toggles the sidebar.\r\n-->\r\n<button (click)=\"onToggleSidebarClicked()\"\r\n        [class.bb-dashboard-header-button--reversed]=\"isSidebarVisible | async\"\r\n        class=\"bb-dashboard-header-button\"\r\n        type=\"button\"\r\n        tabindex=\"0\"\r\n        role=\"switch\">\r\n    <svg xmlns=\"http://www.w3.org/2000/svg\"\r\n         viewBox=\"0 0 157 109\"\r\n         width=\"17\"\r\n         height=\"12\"\r\n         role=\"img\">\r\n        <title>\r\n            Toggle\r\n        </title>\r\n        <path fill=\"#fff\"\r\n              d=\"M82 42V11.2L30 54.5l52 43.3V67h75V42zM9.5 109h-2c-4.1 0-7.5-3.4-7.5-7.5v-94C0 3.4 3.4 0 7.5 0h2C13.6 0 17 3.4 17 7.5v94c0 4.1-3.4 7.5-7.5 7.5z\">\r\n        </path>\r\n    </svg>\r\n</button>\r\n\r\n<!--\r\n    The extra items of the header.\r\n-->\r\n<div class=\"bb-dashboard-header-items\">\r\n    <ng-content></ng-content>\r\n</div>",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None,
                    preserveWhitespaces: false,
                    host: {
                        'class': 'bb-dashboard-header'
                    },
                    styles: [".bb-dashboard-header{z-index:1;width:100%;color:#fff;height:50px;display:-ms-flexbox;display:flex;padding:0 8px;-ms-flex-align:center;align-items:center;background-color:#3f51b5;border-bottom:1px solid #303f9f}.bb-dashboard-header-button{width:68px;height:34px;padding:10px 0;border-radius:4px;-ms-flex-align:center;align-items:center;display:-ms-inline-flexbox;display:inline-flex;-ms-flex-pack:center;justify-content:center;border:1px solid #283593;background-color:transparent}.bb-dashboard-header-button>svg{height:100%;-webkit-transform:none;-ms-transform:none;transform:none;transition:transform .2s cubic-bezier(0,0,.2,1);transition:transform .2s cubic-bezier(0,0,.2,1),-webkit-transform .2s cubic-bezier(0,0,.2,1)}.bb-dashboard-header-button--reversed>svg{-webkit-transform:rotateY(180deg);transform:rotateY(180deg)}.bb-dashboard-header-button:hover{background-color:rgba(0,0,0,.04)}.bb-dashboard-header-button:active{background-color:rgba(0,0,0,.08)}.bb-dashboard-header-items{display:-ms-flexbox;display:flex;margin-left:auto;-ms-flex-align:center;align-items:center}.bb-dashboard-header-items>:not(:first-child){margin-left:8px}@media only screen and (min-width:768px){.bb-dashboard-header-button>svg{-webkit-transform:rotateY(180deg);transform:rotateY(180deg)}.bb-dashboard-header-button--reversed>svg{-webkit-transform:none;-ms-transform:none;transform:none}}"]
                }] }
    ];
    /** @nocollapse */
    BbDashboardHeader.ctorParameters = function () { return [
        { type: BbDashboard, decorators: [{ type: Optional }] }
    ]; };
    return BbDashboardHeader;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BbDashboardSidebar = /** @class */ (function () {
    function BbDashboardSidebar(_platform, _parent) {
        var _this = this;
        this._platform = _platform;
        this._parent = _parent;
        // Bindings.
        this.visible = true;
        // State.
        this._state$ = new BehaviorSubject([]);
        this._localStorageToken = 'bb-dashboard-sidebar-state';
        this.saveCache = function (data) {
            // Get the local storage.
            /** @type {?} */
            var localStorage = _this.getLocalStorage();
            // Check if the local storage exists.
            if (!localStorage) {
                return;
            }
            // Set the cache in the local storage.
            try {
                localStorage.setItem(_this._localStorageToken, JSON.stringify(data));
            }
            catch (error) {
                console.log('Error setting local storage data.');
            }
        };
    }
    /**
     * @return {?}
     */
    BbDashboardSidebar.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        // Retrieve and set the cache.
        this.setCache();
        // Get the visibility observable from the parent
        // if the parent exists.
        /** @type {?} */
        var observable$ = this._parent
            ? this._parent.visibility
            : of(false);
        // Subscribe to get the state changes.
        this._subscription = observable$
            .subscribe(function (value) { return _this.visible = value; });
    };
    /**
     * @return {?}
     */
    BbDashboardSidebar.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        // Unsubscribe to prevent memory leaks.
        this._subscription && this._subscription.unsubscribe();
    };
    /**
     * @param {?} id
     * @return {?}
     */
    BbDashboardSidebar.prototype.registerGroup = /**
     * @param {?} id
     * @return {?}
     */
    function (id) {
        // Get the current groups.
        /** @type {?} */
        var current = this._state$.getValue();
        // Check if the id is already inside the groups.
        if (current.findIndex(function (item) { return item.id === id; }) > -1) {
            throw new Error('Group id was already defined; can only have distinct id\'s.');
        }
        // Check if the item is in the cache
        // and create a new entry.
        /** @type {?} */
        var cacheItem = this._cache.find(function (item) { return item.id === id; });
        /** @type {?} */
        var newEntry = {
            id: id,
            state: cacheItem ? cacheItem.state : 'opened'
        };
        // Push the new groups array.
        this._state$.next(__spread(current, [newEntry]));
        // Return the slice of the state that the group needs.
        return this._state$.pipe(map(function (state) { return state.find(function (item) { return item.id === id; }); }), map(function (group) { return group.state; }));
    };
    /**
     * @param {?} id
     * @return {?}
     */
    BbDashboardSidebar.prototype.unregisterGroup = /**
     * @param {?} id
     * @return {?}
     */
    function (id) {
        // Get the old groups.
        /** @type {?} */
        var oldValue = this._state$.getValue();
        // Calculate the new groups.
        /** @type {?} */
        var newValue = oldValue.filter(function (item) { return item.id !== id; });
        // Push the new groups array.
        this._state$.next(newValue);
    };
    /**
     * @param {?} id
     * @param {?} newState
     * @return {?}
     */
    BbDashboardSidebar.prototype.toggleGroup = /**
     * @param {?} id
     * @param {?} newState
     * @return {?}
     */
    function (id, newState) {
        // Get the old groups.
        /** @type {?} */
        var oldValue = this._state$.getValue();
        // Create the new groups.
        /** @type {?} */
        var newValue = oldValue.map(function (item) {
            return item.id !== id
                ? item
                : { id: id, state: newState };
        });
        // Push the new groups array.
        this._state$.next(newValue);
        // Save in the cache.
        this.saveCache(newValue);
    };
    /**
     * @return {?}
     */
    BbDashboardSidebar.prototype.close = /**
     * @return {?}
     */
    function () {
        // Set the sidebar visibility to true, this means
        // that on mobile the sidebar will be closed.
        this._parent.setSidebarVisibility(true);
    };
    /**
     * @private
     * @return {?}
     */
    BbDashboardSidebar.prototype.getLocalStorage = /**
     * @private
     * @return {?}
     */
    function () {
        // Check if the current platform is a browser.
        if (!this._platform.isBrowser) {
            return null;
        }
        // Check if the window and local storage exist.
        return window && window.localStorage
            ? localStorage
            : null;
    };
    /**
     * @private
     * @return {?}
     */
    BbDashboardSidebar.prototype.setCache = /**
     * @private
     * @return {?}
     */
    function () {
        // Get the local storage.
        /** @type {?} */
        var localStorage = this.getLocalStorage();
        // Check if the local storage exists.
        if (!localStorage) {
            return;
        }
        // Retrieve the raw data from the storage.
        /** @type {?} */
        var rawData = localStorage.getItem(this._localStorageToken);
        // Try to parse the data.
        /** @type {?} */
        var parsedData = null;
        // Only parse the data when it is not null.
        if (rawData !== null) {
            try {
                parsedData = JSON.parse(rawData);
            }
            catch (error) {
                console.log('Error parsing local storage data.');
            }
        }
        // Set the cache to the parsed data.
        this._cache = parsedData || [];
    };
    BbDashboardSidebar.decorators = [
        { type: Component, args: [{
                    selector: 'bb-dashboard-sidebar',
                    template: "<!--\r\n    The header of the sidebar.\r\n-->\r\n<header class=\"bb-dashboard-sidebar-header\">\r\n    <ng-content>\r\n    </ng-content>\r\n</header>\r\n\r\n<!--\r\n    The scroll area that contains the\r\n    groups in the navigation.\r\n-->\r\n<div class=\"bb-dashboard-sidebar-scroll\">\r\n    <ng-content select=\"bb-dashboard-sidebar-group\"></ng-content>\r\n</div>",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None,
                    preserveWhitespaces: false,
                    host: {
                        'class': 'bb-dashboard-sidebar',
                        'role': 'navigation'
                    },
                    styles: [".bb-dashboard-sidebar{top:0;bottom:0;z-index:10;left:-256px;width:256px;height:100vh;display:block;position:fixed;min-width:256px;will-change:transform;-webkit-transform:translateX(256px);-ms-transform:translateX(256px);transform:translateX(256px);border-right:1px solid rgba(0,0,0,.4);transition:transform 250ms cubic-bezier(0,0,.2,1);transition:transform 250ms cubic-bezier(0,0,.2,1),-webkit-transform 250ms cubic-bezier(0,0,.2,1);background:linear-gradient(to bottom,#fff,#f2f2f2) #fff}.bb-dashboard-sidebar.visible{-webkit-transform:none;-ms-transform:none;transform:none}.bb-dashboard-sidebar-header{height:120px;display:-ms-flexbox;display:flex;-ms-flex-align:center;align-items:center;-ms-flex-pack:center;justify-content:center;border-bottom:1px solid #d8d8d8;background-color:rgba(255,255,255,.5)}.bb-dashboard-sidebar-scroll{overflow-y:auto;height:calc(100vh - 120px)}@media only screen and (min-width:768px){.bb-dashboard-sidebar{left:0;z-index:auto;-webkit-transform:none;-ms-transform:none;transform:none;position:relative;margin-left:-256px;transition:margin-left 250ms cubic-bezier(0,0,.2,1)}.bb-dashboard-sidebar.visible{margin-left:0}}"]
                }] }
    ];
    /** @nocollapse */
    BbDashboardSidebar.ctorParameters = function () { return [
        { type: Platform },
        { type: BbDashboard, decorators: [{ type: Optional }, { type: Host }] }
    ]; };
    BbDashboardSidebar.propDecorators = {
        visible: [{ type: HostBinding, args: ['class.visible',] }]
    };
    return BbDashboardSidebar;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BbDashboardSidebarGroup = /** @class */ (function () {
    function BbDashboardSidebarGroup(_parent) {
        this._parent = _parent;
        // Inputs.
        this.id = null;
        this.icon = null;
        this.title = null;
        // State.
        this.state = 'opened';
    }
    Object.defineProperty(BbDashboardSidebarGroup.prototype, "isExpanded", {
        // Host bindings.
        get: 
        // Host bindings.
        /**
         * @return {?}
         */
        function () {
            return this.state === 'opened';
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    BbDashboardSidebarGroup.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        // Check if the id and title have been supplied.
        if (!this.id || !this.title) {
            throw new Error('Id and title are required.');
        }
        // Register the group at the parent and
        // retrieve the slice of the state.
        /** @type {?} */
        var observable$ = this._parent
            ? this._parent.registerGroup(this.id)
            : of('opened');
        // Subscribe to the state.
        this._subscription = observable$
            .subscribe(function (state) { return _this.state = state; });
    };
    /**
     * @return {?}
     */
    BbDashboardSidebarGroup.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        // Unsubscribe to prevent memory leaks.
        this._subscription && this._subscription.unsubscribe();
        // Unregister the group at the parent.
        this._parent && this._parent.unregisterGroup(this.id);
    };
    /**
     * @return {?}
     */
    BbDashboardSidebarGroup.prototype.onClick = /**
     * @return {?}
     */
    function () {
        // Change the state.
        /** @type {?} */
        var nextState = this.state === 'opened' ? 'closed' : 'opened';
        // Set the state of the sidebar.
        this._parent && this._parent.toggleGroup(this.id, nextState);
    };
    /**
     * @return {?}
     */
    BbDashboardSidebarGroup.prototype.onItemClicked = /**
     * @return {?}
     */
    function () {
        // Close the sidebar on the parent.
        this._parent && this._parent.close();
    };
    BbDashboardSidebarGroup.decorators = [
        { type: Component, args: [{
                    selector: 'bb-dashboard-sidebar-group',
                    template: "<!--\r\n    The wrapper that contains the title and icon.\r\n-->\r\n<button (click)=\"onClick()\"\r\n        class=\"bb-dashboard-sidebar-group-title\"\r\n        type=\"button\"\r\n        role=\"switch\">\r\n    <i *ngIf=\"icon\"\r\n       class=\"material-icons bb-dashboard-sidebar-group-icon\">\r\n        {{ icon }}\r\n    </i>\r\n    <span *ngIf=\"title\"\r\n          class=\"bb-dashboard-sidebar-group-text\">\r\n        {{ title }}\r\n    </span>\r\n    <span class=\"bb-dashboard-sidebar-group-toggle\">\r\n        <svg xmlns=\"http://www.w3.org/2000/svg\"\r\n             viewBox=\"0 0 157 109\"\r\n             width=\"16\"\r\n             height=\"16\"\r\n             role=\"img\">\r\n            <title>\r\n                Toggle\r\n            </title>\r\n            <path\r\n                d=\"M82 42V11.2L30 54.5l52 43.3V67h75V42zM9.5 109h-2c-4.1 0-7.5-3.4-7.5-7.5v-94C0 3.4 3.4 0 7.5 0h2C13.6 0 17 3.4 17 7.5v94c0 4.1-3.4 7.5-7.5 7.5z\">\r\n            </path>\r\n        </svg>\r\n    </span>\r\n</button>\r\n\r\n<!--\r\n    The sidebar items that contain the\r\n    links to navigate to other pages.\r\n-->\r\n<ng-content select=\"[bb-dashboard-sidebar-item]\">\r\n</ng-content>",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None,
                    preserveWhitespaces: false,
                    host: {
                        'class': 'bb-dashboard-sidebar-group',
                        'role': 'group'
                    },
                    styles: [".bb-dashboard-sidebar-group{color:#000;display:block;overflow:hidden;border-bottom:1px solid rgba(0,0,0,.1);transition:background-color .2s cubic-bezier(0,0,.2,1),padding-bottom .2s cubic-bezier(0,0,.2,1)}.bb-dashboard-sidebar-group.expanded{padding-bottom:20px;background-color:rgba(0,0,0,.04)}.bb-dashboard-sidebar-group.expanded .bb-dashboard-sidebar-group-title{color:#000}.bb-dashboard-sidebar-group.expanded .bb-dashboard-sidebar-item{opacity:1;height:32px;line-height:32px;padding:6px 16px 6px 54px}.bb-dashboard-sidebar-group.expanded .bb-dashboard-sidebar-group-toggle>svg{-webkit-transform:rotate(90deg);-ms-transform:rotate(90deg);transform:rotate(90deg)}.bb-dashboard-sidebar-group-title{margin:0;width:100%;border:none;display:-ms-flexbox;display:flex;cursor:pointer;text-align:left;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;-ms-flex-align:center;align-items:center;padding:17px 15px;color:rgba(0,0,0,.8);background-color:transparent;transition:color .2s cubic-bezier(0,0,.2,1)}.bb-dashboard-sidebar-group-title:focus>.bb-dashboard-sidebar-group-toggle,.bb-dashboard-sidebar-group-title:hover>.bb-dashboard-sidebar-group-toggle{opacity:1}.bb-dashboard-sidebar-group-title:active>.bb-dashboard-sidebar-group-toggle{background-color:rgba(0,0,0,.08)}.bb-dashboard-sidebar-group-icon{margin-right:15px;color:rgba(0,0,0,.25)}.bb-dashboard-sidebar-group-text{width:100%;display:block;font-size:14px;max-width:100%;overflow:hidden;font-weight:500;line-height:15px;white-space:nowrap;text-overflow:ellipsis;text-transform:uppercase}.bb-dashboard-sidebar-group-toggle{opacity:0;width:30px;height:30px;padding:7px;min-width:30px;min-height:30px;border-radius:50%;transition:opacity .2s cubic-bezier(0,0,.2,1),background-color .2s cubic-bezier(0,0,.2,1)}.bb-dashboard-sidebar-group-toggle>svg{width:100%;height:100%;fill:rgba(0,0,0,.25);-webkit-transform:rotate(90deg) rotateY(180deg);transform:rotate(90deg) rotateY(180deg);transition:transform .2s cubic-bezier(0,0,.2,1);transition:transform .2s cubic-bezier(0,0,.2,1),-webkit-transform .2s cubic-bezier(0,0,.2,1)}"]
                }] }
    ];
    /** @nocollapse */
    BbDashboardSidebarGroup.ctorParameters = function () { return [
        { type: BbDashboardSidebar, decorators: [{ type: Optional }, { type: Host }] }
    ]; };
    BbDashboardSidebarGroup.propDecorators = {
        isExpanded: [{ type: HostBinding, args: ['class.expanded',] }],
        id: [{ type: Input }],
        icon: [{ type: Input }],
        title: [{ type: Input }]
    };
    return BbDashboardSidebarGroup;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BbDashboardSidebarItem = /** @class */ (function () {
    function BbDashboardSidebarItem(_parent) {
        this._parent = _parent;
    }
    /**
     * @return {?}
     */
    BbDashboardSidebarItem.prototype.onClick = /**
     * @return {?}
     */
    function () {
        // Trigger the parent on item clicked call
        // so that the sidebar can be closed.
        this._parent && this._parent.onItemClicked();
    };
    BbDashboardSidebarItem.decorators = [
        { type: Component, args: [{
                    selector: '[bb-dashboard-sidebar-item]',
                    template: "<!--\r\n    The content between the tags will\r\n    be reflected here.\r\n-->\r\n<span class=\"bb-dashboard-sidebar-item-content\">\r\n    <ng-content>\r\n    </ng-content>\r\n</span>",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None,
                    preserveWhitespaces: false,
                    host: {
                        'class': 'bb-dashboard-sidebar-item',
                        '[attr.tabindex]': 'tabIndex || 0'
                    },
                    styles: [".bb-dashboard-sidebar-item{height:0;opacity:0;padding:0;display:-ms-flexbox;display:flex;line-height:0;cursor:pointer;font-size:14px;font-weight:500;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;margin-right:20px;-ms-flex-align:center;align-items:center;text-decoration:none;transition-duration:.2s;will-change:opacity,height;border-top-right-radius:16px;border-bottom-right-radius:16px;color:rgba(0,0,0,.85)!important;transition:height .2s cubic-bezier(0,0,.2,1),opacity .2s cubic-bezier(0,0,.2,1) 50ms,color .2s cubic-bezier(0,0,.2,1),background-color .2s cubic-bezier(0,0,.2,1)}.bb-dashboard-sidebar-item:focus,.bb-dashboard-sidebar-item:hover{background-color:rgba(0,0,0,.05)}.bb-dashboard-sidebar-item:active{background-color:rgba(0,0,0,.1)}.bb-dashboard-sidebar-item.active,.bb-dashboard-sidebar-item.active:active,.bb-dashboard-sidebar-item.active:focus,.bb-dashboard-sidebar-item.active:hover{color:#000;background-color:rgba(0,0,0,.15)}.bb-dashboard-sidebar-item-content{overflow:hidden;max-width:100%;white-space:nowrap;text-overflow:ellipsis}"]
                }] }
    ];
    /** @nocollapse */
    BbDashboardSidebarItem.ctorParameters = function () { return [
        { type: BbDashboardSidebarGroup, decorators: [{ type: Optional }] }
    ]; };
    BbDashboardSidebarItem.propDecorators = {
        tabIndex: [{ type: Input }],
        onClick: [{ type: HostListener, args: ['click',] }]
    };
    return BbDashboardSidebarItem;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var DECLARATIONS_EXPORTS = [
    BbDashboard,
    BbDashboardHeader,
    BbDashboardSidebar,
    BbDashboardSidebarGroup,
    BbDashboardSidebarItem
];
var BbDashboardModule = /** @class */ (function () {
    function BbDashboardModule() {
    }
    BbDashboardModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule],
                    declarations: __spread(DECLARATIONS_EXPORTS),
                    exports: __spread(DECLARATIONS_EXPORTS)
                },] }
    ];
    return BbDashboardModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { Platform, BbDashboard, BbDashboardHeader, BbDashboardSidebar, BbDashboardSidebarGroup, BbDashboardSidebarItem, BbDashboardModule };

//# sourceMappingURL=bravobit-bb-foundation.js.map